/*
 Luminardo OBDII electronic gauge
 with I2C 128x64 SSD1306 OLED display
 
 Copyright (c) 2015 Dmitry Pakhomenko.
 dmitryp@magictale.com
 http://magictale.com/luminardo
 
 This example code is in the public domain.
 */

#ifndef Luminardo_OBDII_BT_128x64_i2c_h
#define Luminardo_OBDII_BT_128x64_i2c_h


enum enum_SysState
{
  sysSplashScreen,
  sysLogo,  
  sysStarting,
  sysCheckingOBDII,
  sysBatWarning,
  sysFuelWarning,
  sysScreenOne,
  sysScreenTwo,
  sysScreenThree,
  sysFailure
};

enum enum_BtState
{
  btConnecting,
  btConnected,
  btDisconnected  
};


//#define TEST_CONNECTION_2_VEHICLE
//#define ELM_CONSOLE_BI_REDIRECT

#define DISP_FLIP_PEDIOD 500
#define LOGO_TIMEOUT 4000
#define SPLASHSCREEN_TIMEOUT 2000
#define TEMPERATURE_REFRESH 5000
#define TANK_LEVEL_REFRESH 5000
#define BAT_VOLTAGE_REFRESH 5000
#define ELM_RX_BUF_SIZE 30
#define DEF_BT_CMD_TIMEOUT 1000
#define TEN_SEC_BT_CMD_TIMEOUT 20000
#define BT_REPLY_SUBSTR_FOUND 0xFF
#define BATTERY_VOLTAGE_WARN_THRESHOLD 110 //Multiplied by 10
#define TANK_LEVEL_WARN_THRESHOLD 30

volatile enum_SysState sys_state;
volatile enum_BtState bt_state;
volatile unsigned long last_time_check;
volatile unsigned long last_time_disp_flip;
volatile unsigned long last_temp_refresh;
volatile unsigned long last_tank_level_refresh;
volatile unsigned long last_bat_voltage_refresh;
OneWire ds(TEMP_SNSR_PIN);               //DS18B20 - a 1Wire temperature sensor from Dallas Semiconductor
volatile uint8_t dsState;                //temperature sensor state (to avoid explicit usage of delays)
volatile float temperature;              //current temperature
uint8_t dsAddr[8];  //temperature sensor address
uint8_t dsData[12]; //temperature sensor data buffer
char rxData[ELM_RX_BUF_SIZE];
char rxIndex = 0;
uint8_t tank_level;
uint8_t bat_voltage;
uint8_t speed;
uint16_t rpm;

#endif
